package de.fraunhofer.iem.dataprovider.taskManager.tasks

import de.fraunhofer.iem.dataprovider.taskManager.Event
import de.fraunhofer.iem.dataprovider.taskManager.SequenceTaskDoneEvent
import java.util.*


data class GitProject(val name: String, val uri: String)
class GitTask(
    override val type: TaskType,
    private val getGitProject: () -> GitProject,
//    private val outputPath: String,
    private val responseChannel: suspend (task: Event) -> Unit,
    override val sequenceId: UUID?
): Task() {

    override suspend fun execute() {
        val gitProject = getGitProject()
        logger.info("Cloning ${gitProject.name}")
        if (sequenceId != null) {
            responseChannel(SequenceTaskDoneEvent(sequenceId!!))
        }
//        val git: Git = Git.cloneRepository()
//            .setURI(gitProject.uri)
//            .setDirectory(
//                File("/tmp/opencode/${gitProject.name}-${taskID}")) // TODO: add output path
//            .call()
//        git.close()
//        responseChannel(DoneTask("Successfully cloned ${gitProject.name}"))
    }
}